%{
/*
 * Hybrid Logic Model Checker 0.9 - HL Formula lexer
 * 
 * Copyright (C) 2005 Luigi Dragone
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; version 2.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *   
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 * 
 * Luigi Dragone <luigi@luigidragone.com>
 */


#include "y.tab.h"
#include <string.h>
 
extern int lineno;
%}

%%
[ \t]+        /* ignore */;
\n              lineno++;

"&"             return '&';
"!"             return '!';
"|"             return '|';
"->"			return 'I';
"<"             return '<';
">"             return '>';
"["             return '[';
"]"             return ']';
"-"             return '-';
"@"	            return '@';
"E"             return 'E';
"B"             return 'B';
"A"             return 'A';
"("             return '(';
")"             return ')';
"T"				return 'T';
"F"				return 'F';

[a-z_][a-zA-Z0-9_]*    { yylval.stringconst = (char*)malloc(strlen(yytext) + 1);
                         sprintf(yylval.stringconst, "%s", yytext);
                         return tIDENTIFIER; }
.               /* ignore */;
%%
